// ########################### Declaracion de variables, constantes y librerias #############################################

int ledPin = 13;
int relayPin = 6; 
const int umbralCarga = 30; 
const int sensorPin = A0;   // selecciono la entrada para el sensor (reed Switch)
int sensorValue;      // variable que almacena el valor raw (0 a 1023)
float value;        // variable que almacena el voltaje (0.0 a 4.0)

volatile byte rpmcount;
unsigned int rpm;
unsigned long timeold;

#include <LiquidCrystal.h>
// LiquidCrystal lcd(rs, en, d4, d5, d6, d7);
LiquidCrystal lcd(7, 8, 9, 10, 11, 12);

// ########################### funciones de interrupciones ###################################################################

void rpm_fun()
{
//Cada rotación se genera una interrupcion que llama a la funcion e incrementa las revoluciones.
  rpmcount++;

}

// ########################### Setup  ###################################################################
 
void setup() {
  lcd.begin(16, 2); // inicializo el LCD


//Trabajando con interrupciones: Interrupcion 0 en el pin digital 2. Esto ocurre cuando el detector IR detecta señal.
//El Triggers en estado FALLING cambia HIGH to LOW
  attachInterrupt(0, rpm_fun, FALLING);

//Declaro pines y enciendo el led 

  pinMode(ledPin, OUTPUT);
  pinMode(relayPin, OUTPUT);
  digitalWrite(ledPin, HIGH);
  digitalWrite(relayPin, LOW);
  

  rpmcount = 0;
  rpm = 0;
  timeold = 0;
} // ############################## Fin del setup ###########################################################


// ########################### Loop ppal ###################################################################
void loop() {


  
sensorValue = analogRead(sensorPin);        // realizar la lectura
value = fmap(sensorValue, 0, 1023, 0.0, 4.0);   // cambiar escala a 0.0 - 4.0


//Actualizo las revoluciones cada 1 segundo
delay(1000);
//No interrumpo el proceso durante el calculo
detachInterrupt(0);

rpm = 30*1000/(millis() - timeold)*rpmcount;
timeold = millis();
rpmcount = 0;


sensorValue = analogRead(sensorPin);        // realizar la lectura
value = fmap(sensorValue, 0, 1023, 0.0, 4.00); //Cargo el valor en escala de 0 a 4 v   



//Imprimo en lcd


lcd.clear();
lcd.setCursor(2, 0);

//Si las revoluciones superan el umbral de giro se activa el relay y se imprime en pantalla el estado de carga (ON/OFF )
if (rpm > umbralCarga) {
    digitalWrite(relayPin, HIGH);
    lcd.print( "   CARGA: ON");     
} else { 
    digitalWrite(relayPin, HIGH);
    lcd.print( "   CARGA: OFF");  
   
}
lcd.print( "RPM= " );
lcd.print(rpm);

lcd.setCursor(2, 1);
lcd.print("BAT: " );
lcd.print(value);




//Activo las interrupciones
attachInterrupt(0, rpm_fun, FALLING); 

   
}  //  ########################### Fin del loop principal  ###################################################################

 

//  ########################### Funciones  ###################################################################

// cambio de escala entre floats
float fmap(float x, float in_min, float in_max, float out_min, float out_max)
{
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}
